package com.dsic.gj_erp.controller.jcsj;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.DmTltpdf;
import com.dsic.gj_erp.bean.jcsj.excel.PlExcel;
import com.dsic.gj_erp.bean.jcsj.vo.BomVO;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.DmTltpdfService;
import com.dsic.gj_erp.service.jcsj.impl.BomUploadServiceImpl;
import com.dsic.gj_erp.service.sy.SYService;
import com.dsic.gj_erp.util.FileUtil;
import io.swagger.annotations.Authorization;
import org.apache.commons.lang3.StringUtils;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.text.PDFTextStripper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@RestController
@RequestMapping("/dmBom")
public class DmBomController {

    @Autowired
    DmBomService dmBomService;

    @Autowired
    BomUploadServiceImpl bomUploadService;
    @Autowired
    SYService syService;
    @Autowired
    DmTltpdfService tltpdfService;

    @PostMapping("/saveDegs")
    @AuthFunction
    public ResultBean saveDegs( @RequestBody List<DmBom> list ){
        for (DmBom bom : list) {
            dmBomService.update(new UpdateWrapper<DmBom>().eq("idd",bom.getIdd())
                    .set("pkgs",bom.getPkgs())
                    .set("dmgs",bom.getDmgs())
                    .set("qgs",bom.getQgs())
            );
        }
        return new ResultBean();
    }
    @PostMapping("/uploadPDF")
    @Authorization("")
    @Transactional
    @ResponseBody
    public ResultBean uploadPDF(@RequestParam("file") MultipartFile[] fileList)throws IOException {

        for (MultipartFile file : fileList) {
         String url= FileUtil.handlerUpload(file,"/tltpdf");
        PDDocument document = PDDocument.load(file.getInputStream());
        int pageNum = document.getNumberOfPages();
        PDFTextStripper stripper = new PDFTextStripper();
//        stripper .setSortByPosition(true); //设置为true 则按照行进行读取，默认是false
//        // 3、获取指定页面的文本内容
        stripper.setStartPage(1);// 设置起始页面，这里设置成2，就表示读取第一个页面
        stripper.setEndPage(1); // 设置结束页面，这里设置成2，就表示读取第一个页面
        String[] text = stripper.getText(document).split("\r\n");
        String dcCh=text[46];
        String pl=text[38].substring(1,4);
        String th=text[29];
        //删除导入过的同船、批量、图号的数据，
        tltpdfService.remove(new QueryWrapper<DmTltpdf>()
                                            .eq("dc_ch",dcCh)
                                            .eq("pl",pl)
                                            .eq("th",th)
                             );
        List<DmTltpdf> list=new ArrayList<>();
        for (int i = 1; i <= pageNum; i++) {
            stripper.setStartPage(i);
            stripper.setEndPage(i);
            String s = stripper.getText(document);//本页文字内容
            String[] a=s.split("\r\n");//分行
            String tlth=i>1?s.split("序号零件编号")[1].split(" ")[5]:"";
//            System.out.println("第 " + i +"/"+pageNum+ " 页 :" );
            for (int j=0;j<a.length;j++){
                DmTltpdf tltpdf=new DmTltpdf();
                tltpdf.setDcCh(dcCh);
                tltpdf.setTh(th);
                tltpdf.setPl(pl);
                tltpdf.setTlth(tlth);
                tltpdf.setPageNum(i +"/"+pageNum);
                tltpdf.setRows((j+1) +"/"+a.length);
                tltpdf.setContent(a[j]);
                tltpdf.setFilePath(url);
                list.add(tltpdf);
//                System.out.println("第 " + (j+1) +"/"+a.length+ " 行 :");
//                System.out.println(a[j]);
            }
            if (i==1)continue;
            //根据当前页数据，修改BOM中零件属性 坡口 打磨 曲
            int ljCount=  s.split("\\|")[0].split("\r\n").length;//零件数量
            if (ljCount==11||ljCount==21||ljCount==31){
                //取用下标count-1 至 count*2-2的数组，为属性
                String[] sxArray=getArrayByIndex(a,ljCount-1,ljCount*2-2);

                //取用下标count*2-2 至 count*3-3 的数组，为零件号
                String[] ljArray=getArrayByIndex(a,ljCount*2-2,ljCount*3-3);

                System.out.println(ljCount);
                System.out.println(i);
                for (int j = 0; j < ljArray.length; j++) {
                    String ljbh;//零件号
                    String sx;//属性
                    if (i==0){
                        String[] b= ljArray[j].split("0\\|");
                        ljbh=b[b.length-1];
                        sx=sxArray[j].split("\\|")[4];
                    }else {
                        ljbh=ljArray[j];
                        sx=sxArray[j].split("\\|")[4];
                    }
                    updateBom(sx,dcCh,pl,tlth,ljbh);
                }
            }else if (ljCount==1){
                //"1,11,21,31"
                String[] ljxx=  a[0].split("\\|");
                String ljbh=  ljxx[ljxx.length-1];//零件号
                String sx=  ljxx[4];//属性
                updateBom(sx,dcCh,pl,tlth,ljbh);
            }else {
                //取用下标count 至 count*2-1的数组，为属性
                String[] sxArray=getArrayByIndex(a,ljCount,ljCount*2-1);
                //取用下标count*2 至 count*3-1 的数组，为零件号
                String[] ljArray=getArrayByIndex(a,ljCount*2,ljCount*3-1);
                for (int j = 0; j < ljArray.length; j++) {
                    String ljbh=ljArray[j];//零件号
                    String sx=sxArray[j].split("\\|")[4];//属性
                    updateBom(sx,dcCh,pl,tlth,ljbh);
                }
            }
        }
        tltpdfService.saveBatch(list);
        document.close();
        }
        return new ResultBean();
    }

    public  String[] getArrayByIndex(String[] oldArray,int startIndex,int endIndex){
        int newArraylen=endIndex-startIndex+1;
        String[] array=new String[newArraylen];
        for (int i = 0; i < newArraylen; i++) {
            array[i]=oldArray[i+startIndex];
        }
        return array;
    }
    public void updateBom(String sx,String dcCh,String pl,String tlth,String ljbh){
        //        坡口：K/Y ；曲工序：D/Q ；打磨：E/F/G/H
        if ("K,Y".indexOf(sx)>-1){
            dmBomService.update(new UpdateWrapper<DmBom>().set("pkbs","Y")
                    .eq("dcch",dcCh)
                    .eq("pl",pl)
                    .eq("tzbh",tlth)
                    .eq("ljbh",ljbh)
            );
        }
        if ("D,Q".indexOf(sx)>-1){
            dmBomService.update(new UpdateWrapper<DmBom>().set("qbs","Y")
                    .eq("dcch",dcCh)
                    .eq("pl",pl)
                    .eq("tzbh",tlth)
                    .eq("ljbh",ljbh)
            );
        }
        if ("E,F,G,H".indexOf(sx)>-1){
            dmBomService.update(new UpdateWrapper<DmBom>().set("dmbs","Y")
                    .eq("dcch",dcCh)
                    .eq("pl",pl)
                    .eq("tzbh",tlth)
                    .eq("ljbh",ljbh)
            );
        }
    }
    @PostMapping("/getListBom")
        public ResultBean getListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
            List<BomVO> listBom = dmBomService.getListBom(req,map);

//        String id = syService.f_getpjh("DM", "SYSTEM", "BCHX");
//        String id1= syService.f_getpjh("DM", "SYSTEM", "CLDE");
//        System.out.println("id = " + id);
//        System.out.println("id = " + id1);
//            return  new ResultBean(listBom);
            return  new ResultBean(listBom);
        }
    @PostMapping("/getListBomRealy")
    public ResultBean getListBomRealy(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<DmBom> listBom = dmBomService.getListBomRealy(req,map);
        return  new ResultBean(listBom);
    }
    @PostMapping("/getListBomRealy1")
    public ResultBean getListBomRealy1(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<DmBom> list1 = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", map.get("mbch")));
        List<String> idds = list1.stream().filter(f -> StringUtils.isNotBlank(f.getYidd())).map(DmBom::getYidd).collect(Collectors.toList());
        List<DmBom> list = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", map.get("dcch"))
            .eq(StrUtil.isNotEmpty((String) map.get("fd")), "fd", map.get("dcfd"))
            .eq(StrUtil.isNotEmpty((String) map.get("dcpl")), "pl", map.get("dcpl"))
            .eq(StrUtil.isNotEmpty((String) map.get("zt")), "zt", map.get("zt"))
                .notIn(idds.size()>0,"idd",idds)
            .orderBy(true,true,"pl","fd","type","tzbh","ljbh")
        );
        return  new ResultBean(list);
    }

    @PostMapping("/addListBom")
    @AuthFunction
    public ResultBean addListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<BomVO> dmBoms = bomUploadService.insertBom(req,(String) map.get("dcch"), (String) map.get("dcpl"),"02");
//       dmBomService.insertBoms(dmBoms);
        return  new ResultBean(dmBoms);
    }


    @PostMapping("/saveListBom")
    public ResultBean saveListBom(HttpServletRequest req, @RequestBody List<BomVO> list) throws CustomException {
        bomUploadService.saveBom(req,list,"","",null);
//
        return  new ResultBean();
//        return null;
    }


    @PostMapping("/copyListBom")
    public ResultBean copyListBom(HttpServletRequest req, @RequestBody Map  map) throws CustomException {
        dmBomService.copyListBom(req,map);
//
        return  new ResultBean();
//        return null;
    }

}

