package com.dsic.gj_erp.controller.jhgk;

import cn.hutool.core.util.StrUtil;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.pc.Manager;
import com.dsic.gj_erp.pc.service.三月滚动接口;
import com.dsic.gj_erp.pc.排产;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.concurrent.Semaphore;

@RestController
@RequestMapping("sygdpc")
@AllArgsConstructor
public class 三月滚动排产控制器 {

    private final 三月滚动接口 _三月滚动接口;

    private static Semaphore semaphore = new Semaphore(1);

    @GetMapping("createSygdjh")
    public ResultBean<?> 生成三月滚动(String from, String to){
        try {
            semaphore.acquire();
            return _三月滚动接口.生成三月滚动(from,to);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } finally {
            semaphore.release();
        }
    }

    @GetMapping("pc")
    public ResultBean<?> pc(String from, String to){
        try {
            semaphore.acquire();
            排产.execute(from,to);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } catch (RuntimeException e) {
            e.printStackTrace();
            ResultBean<?> resultBean = new ResultBean<>();
            resultBean.setStatus(10000);
            resultBean.setSuccess(false);
            resultBean.setMessage(e.getMessage());
            return resultBean;
        } finally {
            semaphore.release();
        }
        return new ResultBean<>();
    }

    @GetMapping("sygdjh")
    public ResultBean<?> 获取三月滚动计划(String from, String to) throws InterruptedException {
        semaphore.acquire();
        if (!StrUtil.isAllNotEmpty(from,to)){
            semaphore.release();
            return new ResultBean<>();
        }

        HashMap<Object, Object> map = new HashMap<>();
        if (from.equals(Manager.from)&&to.equals(Manager.to)){
            semaphore.release();
            map.put("zy",Manager.资源池);
            return new ResultBean<>(map);
        }

        try {
            排产.execute(from,to);
        }finally {
            semaphore.release();
        }
        map.put("zy",Manager.资源池);
        return new ResultBean<>(map);
    }

}
