package com.dsic.gj_erp.pc.dto;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.Manager;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.data.钢料需求;
import com.dsic.gj_erp.pc.service.套料图工序接口;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicBoolean;

import static com.dsic.gj_erp.pc.Constant.工序CD;
import static com.dsic.gj_erp.pc.DataFactory.提取资源;
import static com.dsic.gj_erp.pc.DataFactory.搜索可用资源;
import static com.dsic.gj_erp.pc.Manager.from;

@Getter
@Setter
public abstract class 套料图工序 implements 套料图工序接口 {
    protected String kw;
    protected String zl;
    protected 钢料需求 _钢料需求;
    protected Bom bom;
    protected String 需求日期;
    protected Date _需求日期;
    protected List<Constant.工序> 工序;

    public void run(AtomicBoolean atomicBoolean) {
        if (ObjUtil.isEmpty(this.bom)||StrUtil.isEmpty(this.bom.getTzbh())){
            return;
        }
        this._需求日期 = DateUtil.parse(this.需求日期, "yyyy/MM/dd");
        double 需求数量 = 1;
        this.工序.forEach(_工序 -> {
            if (!this.占用资源(_工序,需求数量)){
                //可用资源最大前推日期设置为N天,最大前推日期意味从上料开始最小施工周期
                //fixme 这里应该安装工序设置,暂时写死一个日期
                Optional<资源> 可用资源 = 搜索可用资源(_工序, DateUtil.parse(from, "yyyy/MM/dd"), DateUtil.offsetDay(this._需求日期,0), 需求数量);
                可用资源.ifPresent(_资源 -> {
                    if (_资源.占用资源(_工序,this.bom,需求数量)){
                        this.bom.set所在资源(_资源);
                        this.bom.get已排工序().add(0,_工序);
                    }
                });

                if (bom.get已排工序().size()==0) {
                    Manager.排产结果.add(this.bom);
                    atomicBoolean.set(true);
                }
            }
        });
    }

    protected boolean 占用资源(Constant.工序 _工序,double 需求数量){
        Integer cd = 工序CD.get(_工序);
        DateTime dateTime = DateUtil.offsetDay(this._需求日期, cd);
        资源 _资源 = 提取资源(dateTime);
        AtomicBoolean 占用成功=new AtomicBoolean(false);
        try {
            if (_资源.占用资源(_工序,this.bom,需求数量)){
                this.bom.set所在资源(_资源);
                this.bom.get已排工序().add(0,_工序);
                占用成功.set(true);
            }
        }catch (Exception e){
            e.printStackTrace();
        }

        return 占用成功.get();
    }

    protected boolean 已占资源(Constant.工序 _工序,String 套料图){
        资源 已占资源 = 资源.读取套料图所在资源(套料图);
        工序产能 工序产能 = null;
        if (已占资源 != null) {
            工序产能 = 已占资源.get工序产能MAP().get(_工序);
        }
        if (工序产能 != null && 工序产能.get资源占用图纸表().contains(bom.getTzbh())) {
            bom.set所在资源(已占资源);
            Optional<设备> _设备 = 工序产能.获取已占用设备(bom.getTzbh());
            _设备.ifPresent(bom::set所在设备);
            return true;
        }
        return false;
    }

    @Override
    public 套料图工序 钢料需求(钢料需求 _钢料需求) {
        this._钢料需求=_钢料需求;
        return this;
    }
}
